""" Library to read and write adblock filters from Firefox to Firefox and Opera
	by Dario Varotto
	"""

patternstart='user_pref("adblock.patterns", "'
FirefoxFirstLine="# Mozilla User Preferences"

import os,sys

sourcepath=os.path.dirname( os.path.realpath(sys.argv[0]) )+"/"

targetfile=sourcepath+"filters/ad-filters.txt"
targetAdimportFile=sourcepath+"adblocklist.txt"
confpath=sourcepath+"conf.ini"

def findfile(dir, filename):
	""" Cerca un file a partire da dir """
	result=[]
	for root, dirs, files in os.walk(dir):
		for name in files:
			if name==filename:
				result.append( os.path.join(root, name) )
	return result

def getPrefsPath(filename="prefs.js", configInLine=0, withAdBlock=False, FirstLineShouldBe=None, excludepath="thunderbird"):

	search=None

	if os.path.isfile(confpath): #read conf
		try:
			search=file(confpath).readlines()[configInLine].split("; ")
			#print "Ho pescato da file %s"%search
			search=map(str.strip, search)
			for f in search:
				if not os.path.isfile(f): #if some file doesn't exist research
					#print "%s non c'e` piu`"%f
					search=None
					break
		except:
			search=None

	if not search: #search and write to conf
		print "Cerco %s... un attimo di pazienza."%filename
		#search=os.popen(searchcommand).readlines() #command
		searchdir=os.path.expanduser("~")
		search=findfile(searchdir, filename)

		search=map(str.strip, search)
		#print "find mi da ",search

	if FirstLineShouldBe:
		for f in search:	#remove all files that aren't mozilla user preferences (see stating comment)
			prefs=file(f,"r") #read pref file
			if prefs.readline().startswith(FirstLineShouldBe):
				#print "%s e` un file valido"%f
				pass
			else:
				del( search[search.index(f)] )
				print "%s NON e` valido"%f
			prefs.close()

	if withAdBlock:	#remove all entry without Adblock entry
		for f in search:
			prefs=file(f,"r")
			content=prefs.read()
			prefs.close()
			if	content.find(patternstart)==-1:
				print "Non c'e` Adblock in %s"%f
				del( search[search.index(f)] )

	if excludepath:	#remove path containg "thunderbird"
		for f in search:
			if f.find(excludepath) != -1:
				print "Thunderbird: salto questa configurazione"
				del( search[search.index(f)] )


	if not search:
		print "Non ho trovato alcun profilo valido."
		if filename=="prefs.js":
			#print " sicuro di avere installato Firefox e Adblock?"
			pass
		elif filename=="opera6.ini":
			#print " sicuro di avere installato Opera6?"
			pass

	return search

def subFFfilters(f, filters):
	""" Change filters in file f """
	#print "Cambio i settaggi di FF in %s"%f
	oldpref=file(f,"r").readlines()
	if not oldpref[0].startswith(FirefoxFirstLine):
		print "%s non e` un file di configurazione valido"
	prefs=file(f,"w") #rewrite pref file
	found=False
	for line in oldpref:
		if line.startswith(patternstart): #line with filters found
			#print "Riscrivo i filtri da %s"%f
			found=True
			line =patternstart+filters+'");\n'
			prefs.write(line)
		else: #linea qualsiasi
			prefs.write(line)

	if not found:
		print "In %s non c'erano settaggi per AdBlock, li aggiungo ora."%f
		prefs.write("\n")
		prefs.write(patternstart+filters+'");\n')
		prefs.write('user_pref("adblock.frameobjects", false);\n') #hide object tabs too

	prefs.close()

def Opera6Search():
	return getPrefsPath("opera6.ini", configInLine=1)

def addOperaFilters(opera6ini, filters):
	operapath=os.path.dirname(opera6ini)
	filtersfile=os.path.join(operapath, "filters.ini")
	op6ini=file(opera6ini,"r")
	inifile=op6ini.readlines()
	op6ini.close()

	inAdvPref=False
	found=False
	modified=False
	uffline="URL Filter File=%s"%filtersfile
	newinifile=[]
	#cerco in opera6ini la sezione "[Adv User Prefs]"
	#la scorro in cerca di "URL Filter File="
	#e ci piazzo il percordo di opera6ini + "filters.ini"

	for line in inifile:
		line=line.strip()
		if not line: continue

		if inAdvPref:
			if line.startswith("URL Filter File="):
				found=True
				if line!=uffline:
					modified=True
					line=uffline

			if line.startswith("["):
				if not found:
					newinifile.append(uffline+"\n")
					modified=True

				inAdvPref=False
			pass

		else:
			if line.startswith("[Adv User Prefs]"):	#entro in advpref

				inAdvPref=True

		if line.startswith("["):
			newinifile.append("\n")

		newinifile.append(line+"\n") #copio nel nuovo file

	if modified:
		print "Modificato il file di configurazione principale di Opera"
		op6ini=file(opera6ini,"w")
		inifile=op6ini.writelines(newinifile)
		op6ini.close()
	#print newinifile

	#poi scrivo in "filters.ini"
	print "Riscrivo i filtri per Opera"
	newfilterfile=file(filtersfile,"w")
	newfilterfile.write("[prefs]\nprioritize excludelist=1\n\n")
	newfilterfile.write("[include]\n*\n\n")
	newfilterfile.write("[exclude]\n")
	#seguito dalla lista di filtri
	for rule in filters.split(" "):
		newfilterfile.write(rule+"\n")

def writePrefsPath(firefoxpath,operapath):
	f=file(confpath,"w")

	if firefoxpath:
		firefoxpath="; ".join(firefoxpath)
	else:
		firefoxpath=""

	if operapath:
		operapath="; ".join(operapath)
	else:
		operapath=""

	f.write( "%s\n%s\n"%(firefoxpath,operapath))

	f.close()